<center><a href="petscprom.c">Actual source code: petscprom.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:28:51+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><font color="#B22222">/*  $Id: petsc_prom.c,v 1.7 2005/04/07 17:43:33 adams Exp $ */</font>
<a name="line2">  2: </a><font color="#B22222">/*  Author:             Mark F. Adams    */</font>
<a name="line3">  3: </a><font color="#B22222">/*  Copyright (c) 2004 by Mark F. Adams  */</font>
<a name="line4">  4: </a><font color="#B22222">/*  Filename:           petsc_prom.c     */</font>
<a name="line5">  5: </a>
<a name="line6">  6: </a><font color="#B22222">/*  -------------------------------------------------------------------- </font>
<a name="line7">  7: </a><font color="#B22222">    </font>
<a name="line8">  8: </a><font color="#B22222">     This file implements a Prometheus preconditioner for matrices that use</font>
<a name="line9">  9: </a><font color="#B22222">     the <A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> interface (various matrix formats).  This wraps the Prometheus</font>
<a name="line10"> 10: </a><font color="#B22222">     class - this is a C intercace to a C++ code.</font>

<a name="line12"> 12: </a><font color="#B22222">     Prometheus assumes that '<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>' is 'double'.  Prometheus does </font>
<a name="line13"> 13: </a><font color="#B22222">     have a complex-valued solver, but this is runtime parameter, not a </font>
<a name="line14"> 14: </a><font color="#B22222">     compile time parameter.</font>

<a name="line16"> 16: </a><font color="#B22222">     The following basic routines are required for each preconditioner.</font>
<a name="line17"> 17: </a><font color="#B22222">          PCCreate_XXX()          - Creates a preconditioner context</font>
<a name="line18"> 18: </a><font color="#B22222">          PCSetFromOptions_XXX()  - Sets runtime options</font>
<a name="line19"> 19: </a><font color="#B22222">          PCApply_XXX()           - Applies the preconditioner</font>
<a name="line20"> 20: </a><font color="#B22222">          PCDestroy_XXX()         - Destroys the preconditioner context</font>
<a name="line21"> 21: </a><font color="#B22222">     where the suffix "_XXX" denotes a particular implementation, in</font>
<a name="line22"> 22: </a><font color="#B22222">     this case we use _Prometheus (e.g., PCCreate_Prometheus, PCApply_Prometheus).</font>
<a name="line23"> 23: </a><font color="#B22222">     These routines are actually called via the common user interface</font>
<a name="line24"> 24: </a><font color="#B22222">     routines <A href="../../../../../docs/manualpages/PC/PCCreate.html#PCCreate">PCCreate</A>(), <A href="../../../../../docs/manualpages/PC/PCSetFromOptions.html#PCSetFromOptions">PCSetFromOptions</A>(), <A href="../../../../../docs/manualpages/PC/PCApply.html#PCApply">PCApply</A>(), and <A href="../../../../../docs/manualpages/PC/PCDestroy.html#PCDestroy">PCDestroy</A>(), </font>
<a name="line25"> 25: </a><font color="#B22222">     so the application code interface remains identical for all </font>
<a name="line26"> 26: </a><font color="#B22222">     preconditioners.  </font>
<a name="line27"> 27: </a><font color="#B22222"> </font>
<a name="line28"> 28: </a><font color="#B22222">     Another key routine is:</font>
<a name="line29"> 29: </a><font color="#B22222">          PCSetUp_XXX()           - Prepares for the use of a preconditioner</font>
<a name="line30"> 30: </a><font color="#B22222">     by setting data structures and options.   The interface routine <A href="../../../../../docs/manualpages/PC/PCSetUp.html#PCSetUp">PCSetUp</A>()</font>
<a name="line31"> 31: </a><font color="#B22222">     is not usually called directly by the user, but instead is called by</font>
<a name="line32"> 32: </a><font color="#B22222">     <A href="../../../../../docs/manualpages/PC/PCApply.html#PCApply">PCApply</A>() if necessary.</font>
<a name="line33"> 33: </a><font color="#B22222"> </font>
<a name="line34"> 34: </a><font color="#B22222">     Additional basic routines are:</font>
<a name="line35"> 35: </a><font color="#B22222">          PCView_XXX()            - Prints details of runtime options that</font>
<a name="line36"> 36: </a><font color="#B22222">          have actually been used.</font>
<a name="line37"> 37: </a><font color="#B22222">          These are called by application codes via the interface routines</font>
<a name="line38"> 38: </a><font color="#B22222">          <A href="../../../../../docs/manualpages/PC/PCView.html#PCView">PCView</A>().</font>
<a name="line39"> 39: </a><font color="#B22222"> </font>
<a name="line40"> 40: </a><font color="#B22222">     The various types of solvers (preconditioners, Krylov subspace methods,</font>
<a name="line41"> 41: </a><font color="#B22222">     nonlinear solvers, timesteppers) are all organized similarly, so the</font>
<a name="line42"> 42: </a><font color="#B22222">     above description applies to these categories also.  One exception is</font>
<a name="line43"> 43: </a><font color="#B22222">     that the analogues of <A href="../../../../../docs/manualpages/PC/PCApply.html#PCApply">PCApply</A>() for these components are <A href="../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(), </font>
<a name="line44"> 44: </a><font color="#B22222">     <A href="../../../../../docs/manualpages/SNES/SNESSolve.html#SNESSolve">SNESSolve</A>(), and TSSolve().</font>

<a name="line46"> 46: </a><font color="#B22222">     Additional optional functionality unique to preconditioners is left and</font>
<a name="line47"> 47: </a><font color="#B22222">     right symmetric preconditioner application via <A href="../../../../../docs/manualpages/PC/PCApplySymmetricLeft.html#PCApplySymmetricLeft">PCApplySymmetricLeft</A>() </font>
<a name="line48"> 48: </a><font color="#B22222">     and <A href="../../../../../docs/manualpages/PC/PCApplySymmetricRight.html#PCApplySymmetricRight">PCApplySymmetricRight</A>().  The Prometheus implementation is </font>
<a name="line49"> 49: </a><font color="#B22222">     PCApplySymmetricLeftOrRight_Prometheus().</font>

<a name="line51"> 51: </a><font color="#B22222">    -------------------------------------------------------------------- */</font>

<a name="line53"> 53: </a> #include <A href="../../../../../include/private/pcimpl.h.html">private/pcimpl.h</A>
<a name="line54"> 54: </a><font color="#A020F0">#include </font><font color="#666666">"petscpromproto.h"</font><font color="#A020F0"></font>

<a name="line56"> 56: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line57"> 57: </a><font color="#B22222">/*</font>
<a name="line58"> 58: </a><font color="#B22222">   PCCreate_Prometheus - Creates a Prometheus preconditioner context, Prometheus, </font>
<a name="line59"> 59: </a><font color="#B22222">   and sets this as the private data within the generic preconditioning </font>
<a name="line60"> 60: </a><font color="#B22222">   context, <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A>, that was created within <A href="../../../../../docs/manualpages/PC/PCCreate.html#PCCreate">PCCreate</A>().</font>

<a name="line62"> 62: </a><font color="#B22222">   Input Parameter:</font>
<a name="line63"> 63: </a><font color="#B22222">.  pc - the preconditioner context</font>

<a name="line65"> 65: </a><font color="#B22222">   Application Interface Routine: <A href="../../../../../docs/manualpages/PC/PCCreate.html#PCCreate">PCCreate</A>()</font>
<a name="line66"> 66: </a><font color="#B22222">*/</font>

<a name="line68"> 68: </a><font color="#B22222">/*MC</font>
<a name="line69"> 69: </a><font color="#B22222">     <A href="../../../../../docs/manualpages/PC/PCPrometheus.html#PCPrometheus">PCPrometheus</A> - Prometheus (i.e. diagonal scaling preconditioning)</font>

<a name="line71"> 71: </a><font color="#B22222">   Options Database Key:</font>
<a name="line72"> 72: </a><font color="#B22222">.    -pc_prometheus_rowmax - use the maximum absolute value in each row as the scaling factor,</font>
<a name="line73"> 73: </a><font color="#B22222">                        rather than the diagonal</font>

<a name="line75"> 75: </a><font color="#B22222">   Level: beginner</font>

<a name="line77"> 77: </a><font color="#B22222">  Concepts: Prometheus, diagonal scaling, preconditioners</font>

<a name="line79"> 79: </a><font color="#B22222">  Notes: By using <A href="../../../../../docs/manualpages/KSP/KSPSetPreconditionerSide.html#KSPSetPreconditionerSide">KSPSetPreconditionerSide</A>(ksp,PC_SYMMETRIC) or -ksp_symmetric_pc you </font>
<a name="line80"> 80: </a><font color="#B22222">         can scale each side of the matrix by the squareroot of the diagonal entries.</font>

<a name="line82"> 82: </a><font color="#B22222">         Zero entries along the diagonal are replaced with the value 1.0</font>

<a name="line84"> 84: </a><font color="#B22222">.seealso:  <A href="../../../../../docs/manualpages/PC/PCCreate.html#PCCreate">PCCreate</A>(), <A href="../../../../../docs/manualpages/PC/PCSetType.html#PCSetType">PCSetType</A>(), <A href="../../../../../docs/manualpages/PC/PCType.html#PCType">PCType</A> (for list of available types), <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>
<a name="line85"> 85: </a><font color="#B22222">M*/</font>


<a name="line91"> 91: </a><strong><font color="#4169E1"><a name="PCCreate_Prometheus"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCCreate_Prometheus(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line92"> 92: </a>{
<a name="line94"> 94: </a>

<a name="line97"> 97: </a>  PCCreate_Prometheus_private( pc );
<a name="line98"> 98: </a>
<a name="line99"> 99: </a>  <font color="#B22222">/*</font>
<a name="line100">100: </a><font color="#B22222">    Set the pointers for the functions that are provided above.</font>
<a name="line101">101: </a><font color="#B22222">    Now when the user-level routines (such as <A href="../../../../../docs/manualpages/PC/PCApply.html#PCApply">PCApply</A>(), <A href="../../../../../docs/manualpages/PC/PCDestroy.html#PCDestroy">PCDestroy</A>(), etc.)</font>
<a name="line102">102: </a><font color="#B22222">    are called, they will automatically call these functions.  Note we</font>
<a name="line103">103: </a><font color="#B22222">    choose not to provide a couple of these functions since they are</font>
<a name="line104">104: </a><font color="#B22222">    not needed.</font>
<a name="line105">105: </a><font color="#B22222">  */</font>
<a name="line106">106: </a>  pc-&gt;ops-&gt;apply               = PCApply_Prometheus;
<a name="line107">107: </a>  pc-&gt;ops-&gt;applytranspose      = PCApply_Prometheus;
<a name="line108">108: </a>  pc-&gt;ops-&gt;setup               = PCSetUp_Prometheus;
<a name="line109">109: </a>  pc-&gt;ops-&gt;destroy             = PCDestroy_Prometheus;
<a name="line110">110: </a>  pc-&gt;ops-&gt;setfromoptions      = PCSetFromOptions_Prometheus;
<a name="line111">111: </a>  pc-&gt;ops-&gt;view                = PCView_Prometheus;
<a name="line112">112: </a>  pc-&gt;ops-&gt;applyrichardson     = 0;
<a name="line113">113: </a>  pc-&gt;ops-&gt;applysymmetricleft  = 0;<font color="#B22222">/* PCApplySymmetricLeftOrRight_Prometheus; */</font>
<a name="line114">114: </a>  pc-&gt;ops-&gt;applysymmetricright = 0;<font color="#B22222">/* PCApplySymmetricLeftOrRight_Prometheus; */</font>
<a name="line115">115: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>( (<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,
<a name="line116">116: </a>                                            <font color="#666666">"PCSetCoordinates_C"</font>,
<a name="line117">117: </a>                                            <font color="#666666">"PCSetCoordinates_Prometheus"</font>,
<a name="line118">118: </a>                                            PCSetCoordinates_Prometheus);
<a name="line119">119: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>( (<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,
<a name="line120">120: </a>                                            <font color="#666666">"PCSASetVectors_C"</font>,
<a name="line121">121: </a>                                            <font color="#666666">"PCSASetVectors_Prometheus"</font>,
<a name="line122">122: </a>                                            PCSASetVectors_Prometheus);
<a name="line123">123: </a>  <font color="#4169E1">return</font>(0);
<a name="line124">124: </a>}

<a name="line129">129: </a><font color="#B22222">/*@</font>
<a name="line130">130: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/PC/PCSetCoordinates.html#PCSetCoordinates">PCSetCoordinates</A> - sets the coordinates of all the nodes on the local process</font>

<a name="line132">132: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>

<a name="line134">134: </a><font color="#B22222">   Input Parameters:</font>
<a name="line135">135: </a><font color="#B22222">+  pc - the solver context</font>
<a name="line136">136: </a><font color="#B22222">.  dim - the dimension of the coordinates 1, 2, or 3</font>
<a name="line137">137: </a><font color="#B22222">-  coords - the coordinates</font>

<a name="line139">139: </a><font color="#B22222">   Level: intermediate</font>

<a name="line141">141: </a><font color="#B22222">   Notes: coords is an array of the 3D coordinates for the nodes on</font>
<a name="line142">142: </a><font color="#B22222">   the local processor.  So if there are 108 equation on a processor</font>
<a name="line143">143: </a><font color="#B22222">   for a displacement finite element discretization of elasticity (so</font>
<a name="line144">144: </a><font color="#B22222">   that there are 36 = 108/3 nodes) then the array must have 108</font>
<a name="line145">145: </a><font color="#B22222">   double precision values (ie, 3 * 36).  These x y z coordinates</font>
<a name="line146">146: </a><font color="#B22222">   should be ordered for nodes 0 to N-1 like so: [ 0.x, 0.y, 0.z, 1.x,</font>
<a name="line147">147: </a><font color="#B22222">   ... , N-1.z ].</font>

<a name="line149">149: </a><font color="#B22222">.seealso: PCPROMETHEUS</font>
<a name="line150">150: </a><font color="#B22222">@*/</font>
<a name="line151">151: </a><strong><font color="#4169E1"><a name="PCSetCoordinates"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/PC/PCSetCoordinates.html#PCSetCoordinates">PCSetCoordinates</A>(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> dim,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *coords)</font></strong>
<a name="line152">152: </a>{

<a name="line156">156: </a>  PetscTryMethod(pc,PCSetCoordinates_C,(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>*),(pc,dim,coords));
<a name="line157">157: </a>  <font color="#4169E1">return</font>(0);
<a name="line158">158: </a>}

<a name="line162">162: </a><font color="#B22222">/*@</font>
<a name="line163">163: </a><font color="#B22222">   <A href="../../../../../docs/manualpages/PC/PCSASetVectors.html#PCSASetVectors">PCSASetVectors</A> - sets the vectors of all the nodes on the local process</font>

<a name="line165">165: </a><font color="#B22222">   Collective on <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>

<a name="line167">167: </a><font color="#B22222">   Input Parameters:</font>
<a name="line168">168: </a><font color="#B22222">+  pc - the solver context</font>
<a name="line169">169: </a><font color="#B22222">.  nects - the number of vectors</font>
<a name="line170">170: </a><font color="#B22222">-  vects - the vectors</font>

<a name="line172">172: </a><font color="#B22222">   Level: intermediate</font>

<a name="line174">174: </a><font color="#B22222">   Notes: 'vects' is a dense tall skinny matrix with 'nvects' columns and </font>
<a name="line175">175: </a><font color="#B22222">   the number of local equations rows.  'vects' is stored in row major order.</font>

<a name="line177">177: </a><font color="#B22222">.seealso: PCPROMETHEUS</font>
<a name="line178">178: </a><font color="#B22222">@*/</font>
<a name="line179">179: </a><strong><font color="#4169E1"><a name="PCSASetVectors"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../docs/manualpages/PC/PCSASetVectors.html#PCSASetVectors">PCSASetVectors</A>(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> nvects,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *vects)</font></strong>
<a name="line180">180: </a>{

<a name="line184">184: </a>  PetscTryMethod(pc,PCSASetVectors_C,(<A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>*),(pc,nvects,vects));
<a name="line185">185: </a>  <font color="#4169E1">return</font>(0);
<a name="line186">186: </a>}
</pre>
</body>

</html>
